/*
 *      Copyright (c) 2018-2028, Chill Zhuang All rights reserved.
 *
 *  Redistribution and use in source and binary forms, with or without
 *  modification, are permitted provided that the following conditions are met:
 *
 *  Redistributions of source code must retain the above copyright notice,
 *  this list of conditions and the following disclaimer.
 *  Redistributions in binary form must reproduce the above copyright
 *  notice, this list of conditions and the following disclaimer in the
 *  documentation and/or other materials provided with the distribution.
 *  Neither the name of the dreamlu.net developer nor the names of its
 *  contributors may be used to endorse or promote products derived from
 *  this software without specific prior written permission.
 *  Author: Chill 庄骞 (smallchill@163.com)
 */
package org.springblade.bank.message.controller;

import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import io.swagger.annotations.ApiParam;
import com.github.xiaoymin.knife4j.annotations.ApiOperationSupport;
import lombok.AllArgsConstructor;
import javax.validation.Valid;

import org.springblade.core.mp.support.Condition;
import org.springblade.core.mp.support.Query;
import org.springblade.core.tool.api.R;
import org.springblade.core.tool.utils.Func;
import org.springblade.modules.resource.entity.Attach;
import org.springblade.modules.resource.service.IAttachService;
import org.springblade.modules.system.entity.Dept;
import org.springblade.modules.system.service.IDeptService;
import org.springframework.util.Assert;
import org.springframework.web.bind.annotation.*;
import org.springframework.web.bind.annotation.RequestParam;
import com.baomidou.mybatisplus.core.metadata.IPage;
import org.springblade.bank.message.entity.Message;
import org.springblade.bank.message.vo.MessageVO;
import org.springblade.bank.message.wrapper.MessageWrapper;
import org.springblade.bank.message.service.IMessageService;
import org.springblade.core.boot.ctrl.BladeController;

/**
 * 信息發佈 控制器
 *
 * @author BladeX
 * @since 2021-08-13
 */
@RestController
@AllArgsConstructor
@RequestMapping("bank/message")
@Api(value = "信息發佈", tags = "信息發佈接口")
public class MessageController extends BladeController {

	private final IMessageService messageService;
	private final IAttachService attachService;
	private final IDeptService deptService;

	/**
	 * 详情
	 */
	@GetMapping("/detail")
	@ApiOperationSupport(order = 1)
	@ApiOperation(value = "详情", notes = "传入message")
	public R<MessageVO> detail(Message message) {
		Message detail = messageService.getOne(Condition.getQueryWrapper(message));
		return R.data(MessageWrapper.build().entityVO(detail));
	}

	/**
	 * 分页 信息發佈
	 */
	@GetMapping("/list")
	@ApiOperationSupport(order = 2)
	@ApiOperation(value = "分页", notes = "传入message")
	public R<IPage<MessageVO>> list(Message message, Query query) {
		IPage<Message> pages = messageService.page(Condition.getPage(query), Condition.getQueryWrapper(message));
		return R.data(MessageWrapper.build().pageVO(pages));
	}


	/**
	 * 自定义分页 信息發佈
	 */
	@GetMapping("/page")
	@ApiOperationSupport(order = 3)
	@ApiOperation(value = "分页", notes = "传入message")
	public R<IPage<MessageVO>> page(MessageVO message, Query query) {
		IPage<MessageVO> pages = messageService.selectMessagePage(Condition.getPage(query), message);
		return R.data(pages);
	}

	/**
	 * 新增 信息發佈
	 */
	@PostMapping("/save")
	@ApiOperationSupport(order = 4)
	@ApiOperation(value = "新增", notes = "传入message")
	public R save(@Valid @RequestBody Message message) {
		return R.status(messageService.save(message));
	}

	/**
	 * 修改 信息發佈
	 */
	@PostMapping("/update")
	@ApiOperationSupport(order = 5)
	@ApiOperation(value = "修改", notes = "传入message")
	public R update(@Valid @RequestBody Message message) {
		return R.status(messageService.updateById(message));
	}

	/**
	 * 新增或修改 信息發佈
	 */
	@PostMapping("/submit")
	@ApiOperationSupport(order = 6)
	@ApiOperation(value = "新增或修改", notes = "传入message")
	public R submit(@Valid @RequestBody Message message) {
		Attach attach = attachService.getOne(new QueryWrapper<>(new Attach()).lambda().eq(Attach::getLink, message.getFile()));
		Assert.notNull(attach, "找不到附件");
		message.setName(attach.getName());
		message.setDomain(attach.getDomain());
		message.setOriginalName(attach.getOriginalName());
		message.setExtension(attach.getExtension());
		message.setAttachSize(attach.getAttachSize());

		if (messageService.saveOrUpdate(message)){
			message.setCreateDept(message.getDeptId());
			return R.status(messageService.saveOrUpdate(message));
		}

		return R.status(false);
	}


	/**
	 * 删除 信息發佈
	 */
	@PostMapping("/remove")
	@ApiOperationSupport(order = 7)
	@ApiOperation(value = "逻辑删除", notes = "传入ids")
	public R remove(@ApiParam(value = "主键集合", required = true) @RequestParam String ids) {
		return R.status(messageService.deleteLogic(Func.toLongList(ids)));
	}


}
